using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;


public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void ContinueButton_Click(object sender, ImageClickEventArgs e)
    {
    // AGMS App_WebReference URI:
    // https://gateway.agms.com/roxapi/agms.asmx

        AGMSGateway.AGMS_API ws = new AGMSGateway.AGMS_API();
        AGMSGateway.Params wsParams = new AGMSGateway.Params();
        AGMSGateway.Responses wsResponse = new AGMSGateway.Responses();

        wsParams.TransactionType = TransactionType.SelectedValue;
        wsParams.GatewayUserName = GatewayUserName.Text;
        wsParams.GatewayPassword = GatewayPassword.Text;
        wsParams.IPAddress = HttpContext.Current.Request.ServerVariables["REMOTE_ADDR"];

        wsParams.Custom_Field_1 = Custom_Field_1.Text;
        wsParams.Custom_Field_2 = Custom_Field_2.Text;

        if (TransactionType.SelectedValue == "void")
            wsParams.TransactionID = TransactionID.Text;

        if (TransactionType.SelectedValue == "refund")
        {
            wsParams.Amount = Amount.Text;
            wsParams.TransactionID = TransactionID.Text;
        }

        if (TransactionType.SelectedValue == "capture")
        {
            wsParams.Amount = Amount.Text;
            wsParams.TransactionID = TransactionID.Text;
            wsParams.OrderID = OrderID.Text;
            wsParams.Tracking_Number = Tracking_Number.Text;
            wsParams.Shipping_Carrier = Shipping_Carrier.Text;
        }

        if (TransactionType.SelectedValue == "update")
        {
            wsParams.TransactionID = TransactionID.Text;
            wsParams.Tracking_Number = Tracking_Number.Text;
            wsParams.Shipping_Carrier = Shipping_Carrier.Text;
        }

        if (SAFE_Action.SelectedValue == "delete_customer")
        {
            wsParams.SAFE_Action = SAFE_Action.SelectedValue;
            wsParams.SAFE_ID = SAFE_ID.Text;
        }

        if (TransactionType.SelectedValue == "sale" || TransactionType.SelectedValue == "auth" || SAFE_Action.SelectedValue == "add_customer" || SAFE_Action.SelectedValue == "update_customer")
        {
            wsParams.PaymentType = PaymentType.SelectedValue;


            if (SAFE_Action.SelectedValue == "add_customer" || SAFE_Action.SelectedValue == "update_customer")
            {
                wsParams.SAFE_Action = SAFE_Action.SelectedValue;
            }
            wsParams.SAFE_ID = SAFE_ID.Text;

            if (wsParams.PaymentType == "creditcard")
            {
                wsParams.CCNumber = CCNumber.Text;
                wsParams.CCExpDate = CCExpDate.Text;
                wsParams.CVV = CVV.Text;
            }
            if (wsParams.PaymentType == "check")
            {
                wsParams.CheckName = CheckName.Text;
                wsParams.CheckABA = CheckABA.Text;
                wsParams.CheckAccount = CheckAccount.Text;
                wsParams.AccountHolderType = AccountHolderType.SelectedValue;
                wsParams.AccountType = AccountType.SelectedValue;
                wsParams.SecCode = SecCode.SelectedValue;
            }
            wsParams.Amount = Amount.Text;
            wsParams.Tax = Tax.Text;
            wsParams.Shipping = Shipping.Text;
            wsParams.OrderDescription = OrderDescription.Text;
            wsParams.OrderID = OrderID.Text;
            wsParams.PONumber = PONumber.Text;

            wsParams.FirstName = FirstName.Text;
            wsParams.LastName = LastName.Text;
            wsParams.Company = Company.Text;
            wsParams.Address1 = Address1.Text;
            wsParams.Address2 = Address2.Text;
            wsParams.City = City.Text;
            wsParams.State = State.Text;
            wsParams.Zip = Zip.Text;
            wsParams.Country = Country.Text;
            wsParams.Phone = Phone.Text;
            wsParams.Fax = Fax.Text;
            wsParams.EMail = EMail.Text;
            wsParams.Website = Website.Text;

            wsParams.ShippingFirstName = ShippingFirstName.Text;
            wsParams.ShippingLastName = ShippingLastName.Text;
            wsParams.ShippingCompany = ShippingCompany.Text;
            wsParams.ShippingAddress1 = ShippingAddress1.Text;
            wsParams.ShippingAddress2 = ShippingAddress2.Text;
            wsParams.ShippingCity = ShippingCity.Text;
            wsParams.ShippingState = ShippingState.Text;
            wsParams.ShippingZip = ShippingZip.Text;
            wsParams.ShippingCountry = ShippingCountry.Text;
            wsParams.ShippingEmail = ShippingEmail.Text;

            wsParams.ProcessorID = ProcessorID.Text;
        }

        wsResponse = ws.ProcessTransaction(wsParams);

        MSG.Text = "STATUS_CODE: " + wsResponse.STATUS_CODE + "<br>";
        MSG.Text += "STATUS_MSG: " + wsResponse.STATUS_MSG + "<br>";
        MSG.Text += "TRANS_ID: " + wsResponse.TRANS_ID + "<br>";
        MSG.Text += "AUTH_CODE: " + wsResponse.AUTH_CODE + "<br>";
        MSG.Text += "AVS_CODE: " + wsResponse.AVS_CODE + "<br>";
        MSG.Text += "AVS_MSG: " + wsResponse.AVS_MSG + "<br>";
        MSG.Text += "CVV2_CODE: " + wsResponse.CVV2_CODE + "<br>";
        MSG.Text += "CVV2_MSG: " + wsResponse.CVV2_MSG + "<br>";
        MSG.Text += "ORDERID: " + wsResponse.ORDERID + "<br>";
        MSG.Text += "SAFE_ID: " + wsResponse.SAFE_ID + "<br>";
        //MSG.Text += "FULLRESPONSE: " + wsResponse.FULLRESPONSE + "<br>";
        //MSG.Text += "POSTSTRING: " + wsResponse.POSTSTRING + "<br>";

        if (wsResponse.STATUS_CODE == "1")
        {
            MSG.Text = "SUCCESS!<br>" + MSG.Text;
        }
        else
        {
            if (wsResponse.STATUS_CODE == "2")
                MSG.Text = "DECLINE<br>" + MSG.Text;
            else
                MSG.Text = "ERROR<br>" + MSG.Text;
        }
    }
}
